//===================================================
//	Russia Block Plan Game 2.0			A!die Software Studio
//	system.cpp---rbp_system ʵ		by adie
//									http://adie2001.8u8.com
//	Copy right(C) All right recevied			2003-02-25
//===================================================

#include "block.h"

using namespace std;

rbp_system::rbp_system()
{
	srandom(time(NULL));
	display=XOpenDisplay(NULL);
	if(display==NULL)
	{
		cerr<<"Cannot open to display!"<<endl;
		exit(1);
	}

	int intScreenNum=DefaultScreen(display);
	int intWidth=440;
	int intHeight=600;
	int intXPos=0;
	int intYPos=0;
	int intBlackColor=BlackPixel(display,intScreenNum);
	int intWhiteColor=WhitePixel(display,intScreenNum);

	win=XCreateSimpleWindow(display,DefaultRootWindow(display),
					intXPos,intYPos,intWidth,intHeight,0,intBlackColor,intWhiteColor);
	XStoreName(display,win,"RBPGame 2.0 For Linux");
	XMapWindow(display,win);
	gcw=XCreateGC(display,win,0,NULL);
	gcb=XCreateGC(display,win,0,NULL);
	XSetForeground(display,gcb,intBlackColor);
	XSetForeground(display,gcw,intWhiteColor);
}

rbp_system::~rbp_system()
{
	XCloseDisplay(display);
	cout<<"Runed.."<<endl;
}

int rbp_system::rbp_getrnd()
{
	return(random()%19+1);
}

int rbp_system::draw_rectangle(int row,int col)
{
	XFillRectangle(display,win,gcb,20*col,40+20*row,19,19);
	return(1);
}

int rbp_system::clear_rectangle(int row,int col)
{
	XFillRectangle(display,win,gcw,20*col,40+20*row,19,19);
	return(1);
}

int rbp_system::draw_next(int c1,int c2,int c3,int c4)
{
	int row,col;
	if(c1>16|c2>16|c3>16|c4>16) return(0);
	row=(int)((c1-1)/4);
	col=c1-4*row;
	XFillRectangle(display,win,gcb,20*col+320,20*row+60,19,19);
	row=(int)((c2-1)/4);
	col=c2-4*row;
	XFillRectangle(display,win,gcb,20*col+320,20*row+60,19,19);
	row=(int)((c3-1)/4);
	col=c3-4*row;
	XFillRectangle(display,win,gcb,20*col+320,20*row+60,19,19);
	row=(int)((c4-1)/4);
	col=c4-4*row;
	XFillRectangle(display,win,gcb,20*col+320,20*row+60,19,19);
	return(1);
}

void rbp_system::rbp_rbp_clearnext()
{
	XFillRectangle(display,win,gcw,340,60,80,80);
}

void rbp_system::drawborder()
{
	XFillRectangle(display,win,gcw,0,0,440,600);
	XDrawString(display,win,gcb,85,20,"Russia Block Plan Game 2.0  For Linux",37);
	XDrawString(display,win,gcb,220,35,"A!die Software Studio",21);
	XDrawString(display,win,gcb,215,50,"http://adie2001.8u8.com",23);
	XDrawRectangle(display,win,gcb,18,58,303,503);
	XDrawRectangle(display,win,gcb,338,58,83,83);
}

void rbp_system::drawarg(rbp_Abody * bd)
{
	XFillRectangle(display,win,gcw,340,170,100,200);
	char show[14];
	XDrawString(display,win,gcb,340,170,"**************",14);
	XDrawString(display,win,gcb,340,200,"  GAME   VAR  ",14);
	sprintf(show,"MARK: %d",bd->mark);
	XDrawString(display,win,gcb,340,220,show,strlen(show));
	sprintf(show,"SPEED: %d",bd->speed);
	XDrawString(display,win,gcb,340,240,show,strlen(show));
	if(bd->playing) XDrawString(display,win,gcb,343,270,"PLAYING.....",12);
	XDrawString(display,win,gcb,340,300,"**************",14);
	XDrawString(display,win,gcb,340,320," HELP    INFO ",14);
	XDrawString(display,win,gcb,340,340,"START: [Enter]",14);
	XDrawString(display,win,gcb,340,360,"QUIT:    [ESC]",14);
	XDrawString(display,win,gcb,340,380,"LEFT:        a",14);
	XDrawString(display,win,gcb,340,400," lbutton  <---",14);
	XDrawString(display,win,gcb,340,420,"RIGHT:      f  ",14);
	XDrawString(display,win,gcb,340,440," rbutton  --->",14);
	XDrawString(display,win,gcb,340,460,"TURN:   g   t ",14);
	XDrawString(display,win,gcb,340,480,"DOWN:    SPACE ",14);
	XDrawString(display,win,gcb,340,500,"         \\|/   ",14);
	XDrawString(display,win,gcb,340,520,"**************",14);
}

void rbp_system::rbp_delay()
{
	for(unsigned long int i=0;i<=2000000;i++);
}
