//===================================================
//	Russia Block Plan Game 2.0			A!die Software Studio
//	block.cpp ---rbp_block  rbp_FUN ʵ          by adie
//									http://adie2001.8u8.com
//	Copy right(C) All right recevied			2003-02-25
//===================================================

#include "block.h"

using namespace std;

rbp_block::rbp_block():rbp_system()
{
	shape_next=rbp_getrnd();
}

void rbp_block::rbp_rbp_keep(int r1,int c1,int r2,int c2,int r3,int c3)
{
	po_1.row=r1;
	po_1.col=c1;
	po_2.row=r2;
	po_2.col=c2;
	po_3.row=r3;
	po_3.col=c3;
}

int rbp_block::isplace(rbp_Abody *bd,int row,int col)
{
	if(bd->body[row][col]+bd->body[row+po_1.row][col+po_1.col]+bd->body[row+po_2.row][col+po_2.col]+bd->body[row+po_3.row][col+po_3.col]>=1)
		return(0);
	else
		return(1);
}

int rbp_block::show(rbp_Abody *bd,int row,int col)
{
	 draw_rectangle(row,col);
	 draw_rectangle(row+po_1.row,col+po_1.col);
	 draw_rectangle(row+po_2.row,col+po_2.col);
	 draw_rectangle(row+po_3.row,col+po_3.col);

	bd->body[row][col]=1;
	bd->body[row+po_1.row][col+po_1.col]=1;
	bd->body[row+po_2.row][col+po_2.col]=1;
	bd->body[row+po_3.row][col+po_3.col]=1;
	 return(1);
}

int rbp_block::clear(rbp_Abody *bd,int row,int col)
{
	 clear_rectangle(row,col);
	 clear_rectangle(row+po_1.row,col+po_1.col);
	 clear_rectangle(row+po_2.row,col+po_2.col);
	 clear_rectangle(row+po_3.row,col+po_3.col);

	bd->body[row][col]=0;
	bd->body[row+po_1.row][col+po_1.col]=0;
	bd->body[row+po_2.row][col+po_2.col]=0;
	bd->body[row+po_3.row][col+po_3.col]=0;

	 return(1);
}

int rbp_block::showbody(rbp_Abody *bd)
{
		for(int row=1;row<=25;row++)
		for(int col=1;col<=15;col++)
			if(bd->body[row][col])
				draw_rectangle(row,col);
	return(1);
}

int rbp_block::shownext()
{
	rbp_rbp_clearnext();
	switch(shape_next)
	{
		case 1: draw_next(5,6,7,8);break;
		case 2: draw_next(2,6,10,14);break;
		case 3: draw_next(6,10,11,12);break;
		case 4: draw_next(6,7,10,14);break;
		case 5: draw_next(5,6,7,11);break;
		case 6: draw_next(3,7,11,10);break;
		case 7: draw_next(9,10,11,7);break;
		case 8: draw_next(2,6,10,11);break;
		case 9: draw_next(6,7,8,10);break;
		case 10: draw_next(6,7,11,15);break;
		case 11: draw_next(6,9,10,11);break;
		case 12: draw_next(2,6,10,7);break;
		case 13: draw_next(5,6,7,10);break;
		case 14: draw_next(3,7,11,6);break;
		case 15: draw_next(6,7,10,11);break;
		case 16: draw_next(6,10,11,15);break;
		case 17: draw_next(6,7,9,10);break;
		case 18: draw_next(3,7,6,10);break;
		case 19: draw_next(5,6,10,11);break;
		default:break;
	}
	return(1);
}

void rbp_block::killline(rbp_Abody * bd,int row)
{
	 int i,x;
	for(i=15;i>=1;i--)
	{
		bd->body[row][i]=0;
		clear_rectangle(row,i);
	}
	for(x=row;x>1;x--)
		for(i=1;i<=15;i++)
		{
			if(bd->body[x-1][i]==1)
			{
				bd->body[x][i]=1;
				draw_rectangle(x,i);
				bd->body[x-1][i]=0;
				clear_rectangle(x-1,i);
			}
		}
}

int rbp_block::get()
{
	shape_now=shape_next;
	shape_next=rbp_getrnd();
	return(get_on());
}

int rbp_block::get_on()
{
	int return_value=1;
	switch(shape_now)
	{
		case 1:
			rbp_rbp_keep(0,1,0,2,0,3);
			break;
		case 2:
			rbp_rbp_keep(1,0,2,0,3,0);
			break;
		case 3:
			rbp_rbp_keep(1,0,1,1,1,2);
			break;
		case 4:
			rbp_rbp_keep(0,1,1,0,2,0);
			break;
		case 5:
			rbp_rbp_keep(0,1,0,2,1,2);
			break;
		case 6:
			rbp_rbp_keep(1,0,2,0,2,-1);
			break;
		case 7:
			rbp_rbp_keep(0,1,0,2,-1,2);
			break;
		case 8:
			rbp_rbp_keep(1,0,2,0,2,1);
			break;
		case 9:
			rbp_rbp_keep(0,1,0,2,1,0);
			break;
		case 10:
			rbp_rbp_keep(0,1,1,1,2,1);
			break;
		case 11:
			rbp_rbp_keep(1,0,1,1,1,-1);
			break;
		case 12:
			rbp_rbp_keep(1,0,1,1,2,0);
			break;
		case 13:
			rbp_rbp_keep(0,1,0,2,1,1);
			break;
		case 14:
			rbp_rbp_keep(1,0,2,0,1,-1);
			break;
		case 15:
			rbp_rbp_keep(0,1,1,0,1,1);
			break;
		case 16:
			rbp_rbp_keep(1,0,1,1,2,1);
			break;
		case 17:
			rbp_rbp_keep(0,1,1,-1,1,0);
			break;
		case 18:
			rbp_rbp_keep(1,0,0,1,-1,1);
			break;
		case 19:
			rbp_rbp_keep(0,1,1,2,1,1);
			break;
		default:
			return_value=0;
			break;
	}
	return(return_value);
}

int rbp_FUN::DOWN(rbp_Abody * bd,rbp_block * rbp)
{
	rbp->clear(bd,bd->row,bd->col);
	 if(rbp->isplace(bd,bd->row+1,bd->col))
	{               /*һ*/
		bd->row++;
		rbp->show(bd,bd->row,bd->col);
		return(1);
	}
	else
	 {                                /*...*/
	 	rbp->show(bd,bd->row,bd->col);
		int time=bd->testmark(rbp);
		 if(time!=0)
		{                             /*ӷ*/
			bd->mark+=10*time;
			if(bd->mark-bd->speeder_cout>500)            /*Ƿ*/
			{
				bd->speed++;
				if(bd->speed>20) bd->speed=1;
				bd->speeder_cout+=500;
			}
			rbp->drawarg(bd);
		}
		rbp->get();
		bd->initpos();
		if(!rbp->isplace(bd,bd->row,bd->col))  bd->playing=0;
		rbp->show(bd,bd->row,bd->col);
		rbp->shownext();
		return(1);
	}

}

int rbp_FUN::LEFT(rbp_Abody * bd,rbp_block * rbp)
{
	rbp->clear(bd,bd->row,bd->col);
	if(rbp->isplace(bd,bd->row,bd->col-1))
		bd->col--;
	 rbp->show(bd,bd->row,bd->col);
}

int rbp_FUN::RIGHT(rbp_Abody * bd,rbp_block * rbp)
{
	rbp->clear(bd,bd->row,bd->col);
	if(rbp->isplace(bd,bd->row,bd->col+1))
		bd->col++;
	rbp->show(bd,bd->row,bd->col);
}

int rbp_FUN::FDOWN(rbp_Abody * bd,rbp_block * rbp)
{
	for(int i=0;i<5&&DOWN(bd,rbp);i++);
	return(1);
}

int rbp_FUN::TURN(rbp_Abody * bd,rbp_block * rbp)
{
	int shape;
	int shape_old=rbp->shape_now;
	switch(rbp->shape_now)
	{
		case 1: case 3: case 4: case 5: case 7: case 8: case 9:
		case 11: case 12: case 13: case 16: case 18:
		shape=rbp->shape_now+1;
		break;
		case 2: shape=1;break;
		case 6: shape=3;break;
		case 10: shape=7;break;
		case 14: shape=11;break;
		case 15: shape=15;break;
		case 17: case 19: shape=rbp->shape_now-1; break;
		default: break;
	}
	rbp->clear(bd,bd->row,bd->col);
	rbp->shape_now=shape;
	rbp->get_on();
	if(!rbp->isplace(bd,bd->row,bd->col)) 
	{
		rbp->shape_now=shape_old;
		rbp->get_on();
	}
	rbp->show(bd,bd->row,bd->col);
}
